/*------------------------------------------------*/
/* c10/operator.c                                 */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stddef.h>
#include <limits.h> /* ziskame konstanty UINT_MAX a INT_MIN */

#ifdef _MSC_VER
	#define ZU "Iu"
#else
	#define ZU "zu"
#endif

int main(void)
{
    int x, y, z;
    int pole[] = { 5, -10, 15, -20, 25, -30 };
    size_t delka_pole;
    x = y = z = 10;

    x = y++;
    z++;
    printf("%3d %3d %3d\n", x, y, z);
    printf("%3d %3d %3d\n", ++x, y++, ~z);
    printf("%3d %3d %3d\n", x, y, z);

    printf("Mate %2" ZU " bitovy prekladac.\n", sizeof(int *) * 8);
    printf("Pole pole[] zabira %2" ZU " bytu.\n\n", sizeof(pole));

    printf("UINT_MAX = %u = %u\n", UINT_MAX, ~0); /* UINT_MAX = max velikost cisla v typu unsigned int */ 
    printf("INT_MIN = %i = %i \n", INT_MIN, 1 << ((sizeof(int)*8)-1)); /* posunu jednicku az do "nejlevejsiho bitu" */
    printf("-51 >> 1 = %i\n\n", -51 >> 1);

    delka_pole = sizeof(pole) / sizeof(pole[0]);
    printf("Zadejte index pole (od  0 do %2" ZU "): ", delka_pole - 1);

    scanf("%i", &x);
    printf("Zadal jsi %i\n", x);

    /* musi se zkontrolovat platnost zadaneho indexu pole !! */
    x = (x < 0) ? 0 : x;
    delka_pole = ((size_t)x >= delka_pole) ? delka_pole - 1 : (size_t)x;
    printf("pole[%" ZU "] = %i\n", delka_pole, pole[delka_pole]);

    return 0;
}

/*------------------------------------------------*/
